#include <stdio.h>
#include <fcntl.h>   
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include "flowfile.h"
#include "types.h"


int main(int argc,char **argv)
{
 int fd;
 struct flowfileheader header;
 int r;
 struct saveflow sflow;

 if( argc != 2 ) exit(1);

 fd=open(argv[1],O_RDONLY);

 if ( fd < 0 ) {
  perror("Open File");
  exit(1);
 }

 read( fd, &header, sizeof(struct flowfileheader) );
 printf("Start:%lu Stop:%lu\n",ntohl(header.starttime), ntohl(header.stoptime ) );
 printf("Flows:%lu Pkts:%lu Bytes:%qu\n", ntohl( header.flows ),
		 ntohl( header.pkts ),
		 ntohq( header.bytes ) );


   while( ( r = read(fd, &sflow, sizeof( struct saveflow ) ) ) ) {
      if( !r ) break;

      sflow.startoffset = htons( sflow.startoffset );
      sflow.startoffset = htons( sflow.startoffset );
      sflow.sdbytes     = htonl( sflow.sdbytes );
      sflow.sdpkts      = htonl( sflow.sdpkts );
      sflow.dsbytes     = htonl( sflow.dsbytes );
      sflow.dspkts      = htonl( sflow.dspkts );

      switch ( sflow.typenr) {   
          case TCPTYPE:
              sflow.tcp_sport = ntohs( sflow.tcp_sport );
              sflow.tcp_dport = ntohs( sflow.tcp_dport );
              break;
          case UDPTYPE:
              sflow.udp_sport = ntohs( sflow.udp_sport );
              sflow.udp_dport = ntohs( sflow.udp_dport );
              break;
      }
      saveflow_print( &sflow, header.starttime );
   }

   return 0;
}
