#include <stdio.h>
#include <string.h>
#include <time.h>
#include "flowfile.h"


void savedflow_init( struct saveflow* sf )
{
}

void flowfileheader_init( struct flowfileheader *header )
{
    bzero( header, sizeof( struct flowfileheader ) );
    header->magic[0] = 'N';
    header->magic[1] = 'P';
    header->magic[2] = 'F';
    header->magic[3] = 'F';
    header->majver   = 4;
    header->minver   = 0;
}

/*
static char* getProtoName( unsigned char typenr )
{
    switch( typenr )
    {
       case  6: return "TCP";
       case 17: return "UDP";
       default: return "OTH";
    }
}
*/

void saveflow_print( struct saveflow* sf, uint32 starttime )
{
  char sip[ 16 ], dip[ 16 ]; 
  char time[ 9 ];
  time_t flowtime;
  uint16 duration; 
  float bwsd;
  float bwds;


    printip(sip, sf->sip);
    printip(dip, sf->dip);

    switch( sf->typenr ) {
        case TCPTYPE:
            printip(sip, sf->sip );
            printip(dip, sf->dip );
            printf( "TCP(6) %s:%-u",sip, sf->tcp_sport );
            printf( " %s:%-u", dip, sf->tcp_dport );
            break;

        case UDPTYPE:
            printip( sip, sf->sip );
            printip( dip, sf->dip );
            printf( "UDP(17) %s:%-u", sip, sf->udp_sport );
            printf( " %s:%-u", dip, sf->udp_dport );
            break;

        case ICMPTYPE:
            printip( sip, sf->sip );
            printip( dip, sf->dip );
            printf( "ICMP(1) %s %s %u %u", sip, dip, 
                    sf->icmp_type ,
                    sf->icmp_subcode  );
            break;

        default:
            printip( sip, sf->sip );
            printip( dip, sf->dip );
            printf( "OTHER(%u) %s %s",sf->typenr, sip, dip);
            break;
    }

    duration = ntohs( sf->endoffset - sf->startoffset );
    flowtime = (ntohl(starttime)+ntohs(sf->startoffset));
    strftime( time, sizeof time, "%T", localtime( &flowtime ));

    if(duration>2)
    {
        bwsd=.0078*sf->sdbytes/duration;
        bwds=.0078*sf->dsbytes/duration;
    }else  { bwds=bwsd=0; }


    printf( " %lu %lu %.2f %lu %lu %.2f %s %u\n",
            sf->sdpkts, sf->sdbytes, bwsd,
            sf->dspkts, sf->dsbytes, bwds,
            time, duration);
}
