#ifndef NITPICKER_SAVEFLOW_H
#define NITPICKER_SAVEFLOW_H 

#include "djb/uint16.h"
#include "djb/uint32.h"
#include "djb/uint64.h"

/* Definition of Flowfiles */

/* Header of Flowfile */

struct flowfileheader
{
    uint32 starttime;   /* First Flow in File */
    uint32 stoptime;    /* Oldes Flow in File */
    uint64 bytes;       /* Total Bytes of all Flows in File */
    uint32 flows;       /* Number of Flows in File */
    uint32 pkts;        /* Number of Packets in all Flows File */
    char   unused[232]; /* Spare for further use ... 
                           256 Bytes should be reserved for hole flow */
};


/* Definition of new SAVEFLOW type */

typedef  struct {
  uint16 sport;        /* source port */
  uint16 dport;        /* destination port */
} ep_t;

typedef struct {
  unsigned char typenr;
  uint16 startoffset;
  uint16 endoffset;
  uint32 sdpkts;
  uint32 sdbytes;
  uint32 dspkts;
  uint32 dsbytes;
  uint32 srcip;
  uint32 dstip;
  union {
    ep_t    ep;       /* Endpointports for TCP/UDP */
    uint32  icmptype; /* OR Icmptype if ICMP */
  } epv;
} saveflow_t;

/* Definition of old Flowfiles */
/* Will disapeer soon...  */

struct o_fileheader
{
    uint32 starttime;
    uint32 stoptime;
    uint64 bytes;
    uint32 flows;
    uint32 pkts;
};

struct o_saveflow
{
   unsigned char typenr;
   uint16 startoffset;
   uint16 endoffset;
   uint32 sdpkts;
   uint32 sdbytes;
   uint32 dspkts;
   uint32 dsbytes;
};

sytruct o_tcpendpoints_t {
   uint32 src;
   uint32 dst;
   uint16 sport;  
   uint16 dport; 
};

sytruct o_udpendpoints_t {
   uint32 src;
   uint32 dst;
   uint16 sport;  
   uint16 dport; 
};

struct o_otherendpoints_t
{
   uint32 src;
   uint32 dst;
};


#endif
