#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include "mysignal.h"
#include "flowsaver.h"
#include "bpf.h"
#include "iphandler.h"
#include "nitpicker.h"

void signalhandler_init()
{
  signal(SIGINT  , cleankill); 
  signal(SIGQUIT , cleankill);
  signal(SIGHUP  , cleanup);
  signal(SIGTERM , cleankill); 
  signal(SIGSEGV , cleancore);
  signal(SIGBUS  , cleancore);
}

void cleankill( int dummy ) {
  int omask;
  omask = sigblock(0xffffffff);  /* Block all Signals */

  printf("N:Caught KILL Signal .. ending operation and quit\n");
  fflush(stdout);
  iphandler_terminate(1);
  flowsaver_terminate(1);
  read_terminate(1);
  sigsetmask(omask);
}

void cleanup( int dummy )
{
  int omask;
  omask = sigblock(0xffffffff);  /* Block all Signals */

  printf("N:Caught Signal .. dumping flows\n");
  fflush(stdout);
  iphandler_terminate(0);
  flowsaver_terminate(0);
  read_terminate(0);
  sigsetmask(omask);  /* Release them */
}

void cleancore( int dummy )
{
  int omask;
  omask = sigblock(0xffffffff);  /* Block all Signals */

  printf("E:Caught COREDUMP Signal .. dumping flows and corefile\n");
  fflush(stdout);
  iphandler_terminate(1);
  flowsaver_terminate(1);
  read_terminate(0);
  sigsetmask(omask);

#ifdef COREFILE
  kill(getpid(),SIGABRT);
#else
  kill(getpid(),SIGKILL);
#endif
}
